﻿; Common Procedures to be used by my applications.
;
; Paste the Declare section below into the bottom of the Declare section in the main code of an application.
; Use the include command to include this file into the applications.




;{ Copy/Paste below and unrem

  ;- Declare Common Procedures
;   Declare GadgetFit(MARCOAGPINTO_gadget)
;   Declare OpenURL(MARCOAGPINTO_url$)
;   Declare ChangeGadgetColorRed(MARCOAGPINTO_gadget,MARCOAGPINTO_min.f,MARCOAGPINTO_max.f,MARCOAGPINTO_is_real,MARCOAGPINTO_allow_blank)
;   Declare.s ConvertStringToUnix(MARCOAGPINTO_t$)
;   Declare LoadImageEnhanced(MARCOAGPINTO_constant,MARCOAGPINTO_file$,MARCOAGPINTO_error_fails$)
;   Declare.s FloatToString(MARCOAGPINTO_float_value.f,MARCOAGPINTO_decimal_houses,MARCOAGPINTO_remove_dot_zero)
;   Declare.f StringMatchPercentage(MARCOAGPINTO_string1$,MARCOAGPINTO_string2$)
;   Declare AddLineEditorGadget(MARCOAGPINTO_gadget,MARCOAGPINTO_t$)
;   Declare AddLineEditorGadgetBuffer(MARCOAGPINTO_gadget,MARCOAGPINTO_t$)
;   Global MARCOAGPINTO_LineEditorGadgetBuffer$=""
;   Declare ClearCurrentCanvasGadget(MARCOAGPINTO_colour)
;   Declare.s RemoveAccentsString(MARCOAGPINTO_t$)
;   Declare DarkenImage(MARCOAGPINTO_image_number,MARCOAGPINTO_darken_percent)
;   Declare Max(MARCOAGPINTO_value1,MARCOAGPINTO_value2)
;   Declare Min(MARCOAGPINTO_value1,MARCOAGPINTO_value2)
;   Declare SetPos(MARCOAGPINTO_gadget,MARCOAGPINTO_position,MARCOAGPINTO_gadget_type)
;   Declare SetPosTop(MARCOAGPINTO_gadget,MARCOAGPINTO_gadget_type)
;   Declare SetPosBottom(MARCOAGPINTO_gadget,MARCOAGPINTO_gadget_type)
;   Declare.s GetOnlyFilename(MARCOAGPINTO_filename$,MARCOAGPINTO_return_if_blank_filename$)
;   Declare.s GetOnlyPath(MARCOAGPINTO_filename$,MARCOAGPINTO_return_if_blank_filename$)
;   Declare GadgetRefresh(MARCOAGPINTO_gadget)
;   Declare GadgetsRefresh()
;   Declare.s ReplaceChrInString(MARCOAGPINTO_t$,MARCOAGPINTO_chr$,MARCOAGPINTO_position)
;   Declare InvalidValue(MARCOAGPINTO_current_gadget,MARCOAGPINTO_min_value.f,MARCOAGPINTO_max_value.f,MARCOAGPINTO_error_message$,MARCOAGPINTO_flag)
;   Declare.s ShowFileSizeFormatted(MARCOAGPINTO_file_label$,MARCOAGPINTO_file_size_in_bytes,MARCOAGPINTO_brackets_on)
;   Declare.s ExtractStringFromQuotes(MARCOAGPINTO_t$, MARCOAGPINTO_pos_start)
;   Declare SetGadgetTextState(MARCOAGPINTO_gadget, MARCOAGPINTO_value)
;   Declare ToggleTrueFalse(MARCOAGPINTO_boolean)
;   Declare.s CheckSpacesInString(MARCOAGPINTO_t$)
;   Declare ClearGadgetText(MARCOAGPINTO_gadget)
;   Declare.d factorial(MARCOAGPINTO_n)
;   Declare.s TimeToString(MARCOAGPINTO_label$,MARCOAGPINTO_milliseconds_taken)
;   Declare RedIfStringBlank(MARCOAGPINTO_gadget)
;   Declare MaximiseLastColumnListIconGadget(MARCOAGPINTO_gadget,MARCOAGPINTO_window)
;   Declare GetCentreX(MARCOAGPINTO_target_width,MARCOAGPINTO_gadget_width)
;   Declare GetCentreY(MARCOAGPINTO_target_height,MARCOAGPINTO_gadget_height)
;   Declare GetMaxWindowDesktopWidth()
;   Declare GetMaxWindowDesktopHeight()
;   Declare.s TrimStringAll(MARCOAGPINTO_t$)
;   Declare.s ConvertProgressToPercentage(MARCOAGPINTO_current_position.l,MARCOAGPINTO_max_position.l,MARCOAGPINTO_symbols_to_use.l)
;   Declare.s SaveFileRequesterEnhanced(MARCOAGPINTO_title$,MARCOAGPINTO_default_file$,MARCOAGPINTO_pattern$,MARCOAGPINTO_file_extension$)
;   Declare IsFileExist(MARCOAGPINTO_file$,MARCOAGPINTO_file_extension$,MARCOAGPINTO_error_message$)
;   Declare PlaceButtonGadgetAtXY(MARCOAGPINTO_gadget_target,MARCOAGPINTO_x,MARCOAGPINTO_y,MARCOAGPINTO_width,MARCOAGPINTO_height,MARCOAGPINTO_text$,MARCOAGPINTO_add_x_pixels,MARCOAGPINTO_add_y_pixels,MARCOAGPINTO_tooltip$,MARCOAGPINTO_disabled)
;   Declare PlaceButtonGadgetAfterGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_gadget_source,MARCOAGPINTO_width,MARCOAGPINTO_height,MARCOAGPINTO_text$,MARCOAGPINTO_add_x_pixels,MARCOAGPINTO_add_y_pixels,MARCOAGPINTO_tooltip$,MARCOAGPINTO_disabled)
;   Declare PlaceButtonGadgetBeforeGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_gadget_source,MARCOAGPINTO_width,MARCOAGPINTO_height,MARCOAGPINTO_text$,MARCOAGPINTO_add_x_pixels,MARCOAGPINTO_add_y_pixels,MARCOAGPINTO_tooltip$,MARCOAGPINTO_disabled)
;   Declare PlaceImagetAtXY(MARCOAGPINTO_gadget_target,MARCOAGPINTO_x,MARCOAGPINTO_y,MARCOAGPINTO_image_id,MARCOAGPINTO_add_x_pixels,MARCOAGPINTO_add_y_pixels,MARCOAGPINTO_tooltip$,MARCOAGPINTO_disabled)
;   Declare PlaceImageAfterGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_gadget_source,MARCOAGPINTO_image_id,MARCOAGPINTO_add_x_pixels,MARCOAGPINTO_add_y_pixels,MARCOAGPINTO_tooltip$,MARCOAGPINTO_disabled)
;   Declare PlaceImageBeforeGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_gadget_source,MARCOAGPINTO_image_id,MARCOAGPINTO_add_x_pixels,MARCOAGPINTO_add_y_pixels,MARCOAGPINTO_tooltip$,MARCOAGPINTO_disabled)
;   Declare PlaceButtonImageGadgetAtXY(MARCOAGPINTO_gadget_target,MARCOAGPINTO_x,MARCOAGPINTO_y,MARCOAGPINTO_width,MARCOAGPINTO_height,MARCOAGPINTO_image_id,MARCOAGPINTO_add_x_pixels,MARCOAGPINTO_add_y_pixels,MARCOAGPINTO_tooltip$,MARCOAGPINTO_disabled)
;   Declare PlaceButtonImageGadgetAfterGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_gadget_source,MARCOAGPINTO_width,MARCOAGPINTO_height,MARCOAGPINTO_image_id,MARCOAGPINTO_add_x_pixels,MARCOAGPINTO_add_y_pixels,MARCOAGPINTO_tooltip$,MARCOAGPINTO_disabled)
;   Declare PlaceButtonImageGadgetBeforeGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_gadget_source,MARCOAGPINTO_width,MARCOAGPINTO_height,MARCOAGPINTO_image_id,MARCOAGPINTO_add_x_pixels,MARCOAGPINTO_add_y_pixels,MARCOAGPINTO_tooltip$,MARCOAGPINTO_disabled)
;   Declare GadgetXplusGadgetWidth(MARCOAGPINTO_gadget)
;   Declare GadgetYplusGadgetHeight(MARCOAGPINTO_gadget)
;   Declare TextGadgetGadgetFit(MARCOAGPINTO_gadget,MARCOAGPINTO_x,MARCOAGPINTO_y,MARCOAGPINTO_text$)
;   Declare TextReplaceIfDifferentGadget(MARCOAGPINTO_gadget,MARCOAGPINTO_text$,MARCOAGPINTO_gadget_fit)

;}
  
  

  
  ; Common Procedures
  
  
  ; Changes the width and height of a gadget automatically to fits its text
  ;
  ; V1.0 - 25/JUL/2018
  ;        27/JUL/2018
  ; V1.1 - 24/OCT/2019
  ;        o Changed variable names to unique
  ;
  Procedure GadgetFit(MARCOAGPINTO_gadget)
  
    MARCOAGPINTO_x=GadgetX(MARCOAGPINTO_gadget)
    MARCOAGPINTO_y=GadgetY(MARCOAGPINTO_gadget)
    MARCOAGPINTO_w=GadgetWidth(MARCOAGPINTO_gadget)
    MARCOAGPINTO_h=GadgetHeight(MARCOAGPINTO_gadget)
    MARCOAGPINTO_w_new=GadgetWidth(MARCOAGPINTO_gadget,#PB_Gadget_RequiredSize)
    MARCOAGPINTO_h_new=GadgetHeight(MARCOAGPINTO_gadget,#PB_Gadget_RequiredSize)
  
    If MARCOAGPINTO_w<>MARCOAGPINTO_w_new Or MARCOAGPINTO_h<>MARCOAGPINTO_h_new
      ResizeGadget(MARCOAGPINTO_gadget,MARCOAGPINTO_x,MARCOAGPINTO_y,MARCOAGPINTO_w_new,MARCOAGPINTO_h_new)      
    EndIf
  
  EndProcedure    
  
  
  
  
  ; This procedure opens a URL in the different platforms, to simplify/reduce the code
  ;
  ; V1.0 - 07/JAN/2017
  ; V1.1 - 11/JAN/2017
  ;        o Used the URLEncode() to dealing with URLs
  ; V1.2 - 27/JAN/2017
  ;        o Improved the open URL code
  ; V1.3 - 06/APR/2017
  ;        o Improved the open URL code 
  ; V1.4 - 24/OCT/2019
  ;        o Changed variable names to unique
  ;
  Procedure OpenURL(MARCOAGPINTO_url$)
    
    ; Always encode URL
    MARCOAGPINTO_url$=URLEncoder(MARCOAGPINTO_url$)    
    
    ; Open browser in each platform
    CompilerSelect #PB_Compiler_OS
      CompilerCase #PB_OS_Linux
        RunProgram("xdg-open",MARCOAGPINTO_url$,"")
      CompilerCase #PB_OS_Windows
        RunProgram(MARCOAGPINTO_url$)
      CompilerCase #PB_OS_MacOS
        RunProgram("open",MARCOAGPINTO_url$,"") 
    CompilerEndSelect              
    
  EndProcedure
  
  
  

  ; Checks if a gadget has a valid value and turns its background colour #Red or -1 depending on it
  ; And returns the value of the gadget
  ;
  ; Now added flag MARCOAGPINTO_is_real for Real numbers so that it can be also used in StringGadgets - 10/APR/2021
  ;
  ; MARCOAGPINTO_allow_blank = #True = Doesn't change to red if field is blank, for gadgets that can be left blank
  ;
  ; Now it changes the colour if =0 (both integer and real) to the blueish of Windows 11 (#BlueLight=$FFEBC6), can't use constant here because it is not defined
  ;
  ; V1.0 - 25/JUL/2018
  ; V1.1 - 24/OCT/2019
  ;        o Changed variable names to unique
  ; V1.2 - 02/APR/2021
  ;        o If gadget is empty it changes its get value to MARCOAGPINTO_min-1
  ; V1.3 - 06/APR/2021
  ;        07/APR/2021
  ;        10/APR/2021
  ;        18/APR/2021
  ;        19/APR/2021
  ;        o Improved the invalid values datection
  ; V1.4 - 26/NAY/2021
  ;        o Support for blank gadgets
  ; V1.5 - 30/NOV/2021
  ;        o Fix to accept and return float numbers
  ; V1.6 - 23/JUL/2023
  ;        0 Now it changes the colour if =0 (both integer and real) to the blueish of Windows 11 
  ;
  Procedure ChangeGadgetColorRed(MARCOAGPINTO_gadget,MARCOAGPINTO_min.f,MARCOAGPINTO_max.f,MARCOAGPINTO_is_real,MARCOAGPINTO_allow_blank)
  
    MARCOAGPINTO_string$=GetGadgetText(MARCOAGPINTO_gadget)
    MARCOAGPINTO_value.f=ValF(MARCOAGPINTO_string$)
    MARCOAGPINTO_gadget_colour=GetGadgetColor(MARCOAGPINTO_gadget,#PB_Gadget_BackColor)
    MARCOAGPINTO_real_chr$="-" : If MARCOAGPINTO_is_real=#True : MARCOAGPINTO_real_chr$="." : EndIf
    
    
    ; Blank gadget
    If MARCOAGPINTO_allow_blank=#True And MARCOAGPINTO_string$=""
      If MARCOAGPINTO_gadget_colour<>-1 : SetGadgetColor(MARCOAGPINTO_gadget,#PB_Gadget_BackColor,-1) : EndIf
      ProcedureReturn #False
    EndIf
    
    
    ; Change value to MARCOAGPINTO_min.f-1 if gadget blank or invalid
    If Right(MARCOAGPINTO_string$,1)="-" Or Right(MARCOAGPINTO_string$,1)="." Or (FindString(MARCOAGPINTO_string$,"-")>0 And Left(MARCOAGPINTO_string$,1)<>"-") Or (FindString(MARCOAGPINTO_string$,".")>0 And Left(MARCOAGPINTO_string$,1)=".")
      MARCOAGPINTO_value.f=MARCOAGPINTO_min.f-1
    EndIf
    If Len(MARCOAGPINTO_string$)=0
      MARCOAGPINTO_value.f=MARCOAGPINTO_min.f-1
    ElseIf CountString(MARCOAGPINTO_string$,"-")>1 Or CountString(MARCOAGPINTO_string$,".")>1
      MARCOAGPINTO_value.f=MARCOAGPINTO_min.f-1
    Else
      For MARCOAGPINTO_f=1 To Len(MARCOAGPINTO_string$)
        MARCOAGPINTO_t$=Mid(MARCOAGPINTO_string$,MARCOAGPINTO_f,1)
        If (MARCOAGPINTO_t$<"0" Or MARCOAGPINTO_t$>"9") And MARCOAGPINTO_t$<>"-" And MARCOAGPINTO_t$<>MARCOAGPINTO_real_chr$
          MARCOAGPINTO_value.f=MARCOAGPINTO_min.f-1
          Break
        EndIf        
      Next MARCOAGPINTO_f
    EndIf
  
    If MARCOAGPINTO_value.f<MARCOAGPINTO_min.f Or MARCOAGPINTO_value.f>MARCOAGPINTO_max.f
      If MARCOAGPINTO_gadget_colour<>#Red : SetGadgetColor(MARCOAGPINTO_gadget,#PB_Gadget_BackColor,#Red) : EndIf 
    Else
      If MARCOAGPINTO_gadget_colour<>-1 : SetGadgetColor(MARCOAGPINTO_gadget,#PB_Gadget_BackColor,-1) : EndIf 
    EndIf
    
    ; Change colour to blueish if =0 or 0.00000000... - 23/JUL/2023
    If Left(MARCOAGPINTO_string$,1)="0" And Val(StringField(MARCOAGPINTO_string$,1,"."))=0 And Val(StringField(MARCOAGPINTO_string$,2,"."))=0 And GetGadgetColor(MARCOAGPINTO_gadget,#PB_Gadget_BackColor)=-1
      If MARCOAGPINTO_is_real=#False : SetGadgetColor(MARCOAGPINTO_gadget,#PB_Gadget_BackColor,$FFEBC6) : EndIf 
      If MARCOAGPINTO_is_real=#True And CountString(MARCOAGPINTO_t$,".")<=1
        MARCOAGPINTO_t$=StringField(MARCOAGPINTO_string$,2,".")
        If MARCOAGPINTO_t$=ReplaceString(Space(Len(MARCOAGPINTO_t$))," ","0") : SetGadgetColor(MARCOAGPINTO_gadget,#PB_Gadget_BackColor,$FFEBC6) : EndIf
      EndIf
    EndIf
    
    ; Return long or float
    If MARCOAGPINTO_is_real=#False
      ProcedureReturn Val(StringField(Str(MARCOAGPINTO_value.f),1,"."))
    Else
      ProcedureReturn ValF(StrF(MARCOAGPINTO_value.f,Len(StringField(Str(MARCOAGPINTO_value.f),2,"."))))
    EndIf

  EndProcedure
  
  
  
  
  ; Convert string to Unix line endings
  ;
  ; V1.0 - 28/MAR/2018
  ; V1.1 - 24/OCT/2019
  ;        o Changed variable names to unique
  ;
  Procedure.s ConvertStringToUnix(MARCOAGPINTO_t$)

    MARCOAGPINTO_t$=ReplaceString(MARCOAGPINTO_t$,#CRLF$,#LF$)
    MARCOAGPINTO_t$=ReplaceString(MARCOAGPINTO_t$,#CR$,#LF$)
    ProcedureReturn MARCOAGPINTO_t$
  
  EndProcedure  



  
  ; Load an image with an error requester if the loading fails
  ;
  ; Notice the main_path$ variable that must be got in the main code.
  ;
  ;
  ; V1.0 - 05/SEP/2019
  ; V1.1 - 24/OCT/2019
  ;        o Changed variable names to unique
  ;
  Procedure LoadImageEnhanced(MARCOAGPINTO_constant,MARCOAGPINTO_file$,MARCOAGPINTO_error_fails$)
    
    If LoadImage(MARCOAGPINTO_constant,main_path$+MARCOAGPINTO_file$)=#False : MessageRequester("Error",MARCOAGPINTO_error_fails$,#PB_MessageRequester_Error) : EndIf  
    
  EndProcedure
  
  
  
  
  ; To be used to remove round values in % and returns a string.
  ;
  ; Used for float variables.
  ;
  ; For example: 100.0 returns "100"
  ;               24.0 returns "24"
  ;
  ; V1.0 - 01/MAY/2017
  ; V1.1 - 06/SEP/2019
  ;        o Fix: Converting float to string: remove the dot zero didn't work well if more than one decimal house
  ; V1.2 - 24/OCT/2019
  ;        o Changed variable names to unique
  ;
  Procedure.s FloatToString(MARCOAGPINTO_float_value.f,MARCOAGPINTO_decimal_houses,MARCOAGPINTO_remove_dot_zero)
  
      MARCOAGPINTO_ttt$=StrF(MARCOAGPINTO_float_value.f,MARCOAGPINTO_decimal_houses)

      If MARCOAGPINTO_remove_dot_zero=#True And Len(StringField(MARCOAGPINTO_ttt$,2,"."))=MARCOAGPINTO_decimal_houses
        MARCOAGPINTO_ttt$=ReplaceString(MARCOAGPINTO_ttt$,"."+StringField(StrF(0.0,MARCOAGPINTO_decimal_houses),2,"."),"") ; If it ends with ".0" it removes ".0" from the string
      EndIf
    
      ProcedureReturn MARCOAGPINTO_ttt$
    
  EndProcedure
  
  
  
  
  ; Returns in a float variable the % of match of two strings, based on their length
  ;
  ; Example: "abca","a" would return 25.0
  ;
  ; V1.0 - 09/SEP/2019
  ; V1.1 - 24/OCT/2019
  ;        o Changed variable names to unique
  ; 
  Procedure.f StringMatchPercentage(MARCOAGPINTO_string1$,MARCOAGPINTO_string2$)
    
    MARCOAGPINTO_string_length_min=Len(MARCOAGPINTO_string2$)
    MARCOAGPINTO_string_length_max=Len(MARCOAGPINTO_string1$)
    
    ; The max variable is real the max
    If MARCOAGPINTO_string_length_min>MARCOAGPINTO_string_length_max : Swap MARCOAGPINTO_string_length_min,MARCOAGPINTO_string_length_max : EndIf
    
    ; Return the %
    ProcedureReturn MARCOAGPINTO_string_length_min*100.0/MARCOAGPINTO_string_length_max
    
  EndProcedure
  
  
  
  
  ; Add a line of text to an EditorGadget
  ;
  ; V1.0 - 23/SEP/2018
  ; V1.1 - 24/OCT/2019
  ;        o Changed variable names to unique
  ;
  Procedure AddLineEditorGadget(MARCOAGPINTO_gadget,MARCOAGPINTO_t$)
  
    MARCOAGPINTO_t_new$=GetGadgetText(MARCOAGPINTO_gadget)+MARCOAGPINTO_t$+#LF$
    SetGadgetText(MARCOAGPINTO_gadget,MARCOAGPINTO_t_new$)
    
  EndProcedure
  
  
  
  
  ; Add a line of text to an EditorGadget buffer.
  ;
  ; This is to avoid refreshing the EditorGadget all the time because if there are hundreds of lines,
  ; it will cause a huge CPU load.
  ;
  ; So, text is added to a buffer variable which is defined after the DECLARE command and then at the end
  ; (or regularly), one just uses the SetGadgetText normal command ( MARCOAGPINTO_LineEditorGadgetBuffer$ ).
  ;
  ; The first parameter of the procedure is a dummy and does nothing. It is there for just being able to
  ; replace the old Procedure easier with copy/paste of just the procedure.
  ;
  ; V1.0 - 13/JAN/2021
  ;
  Procedure AddLineEditorGadgetBuffer(MARCOAGPINTO_gadget,MARCOAGPINTO_t$)
    
    MARCOAGPINTO_LineEditorGadgetBuffer$+MARCOAGPINTO_t$+#LF$
    
  EndProcedure  
  
  
  
  
  ; Clears the current CanvasGadget with a colour
  ;
  ; V1.0 - 20/SEP/2019
  ; V1.1 - 24/OCT/2019
  ;        o Changed variable names to unique
  ;
  Procedure ClearCurrentCanvasGadget(MARCOAGPINTO_colour)
    
    Box(0,0,OutputWidth(),OutputHeight(),MARCOAGPINTO_colour)
    
  EndProcedure
  
  
  
  
  ; Removes the accents from a string.
  ;
  ; To be used in Proofing Tool GUI for correct sorting of entries.
  ;
  ; It changes the string to lowercase so that there is no priority between lcase and ucase letters.
  ;
  ; Use structured arrays to store the new and old strings, then sorting by the accentless ones and replace at
  ; the end with the accented version.
  ;
  ; V1.0 - 13/NOV/2019
  ; V1.1 - 14/NOV/2019
  ;        o Now it has a data section for clearer view
  ; V1.2 - 22/NOV/2019
  ;        o Added more characters
  ;        o #PB_String_InPlace used for extra speed
  ; V1.3 - 10/DEC/2019
  ;        21/APR/2020
  ;        03/MAY/2020
  ;        05/MAY/2020
  ;        08/MAY/2020
  ;        14/AUG/2022
  ;        27/DEC/2022
  ;        o Added more characters
  ;
  Procedure.s RemoveAccentsString(MARCOAGPINTO_t$)
    
    ; Change string to lowercase
    MARCOAGPINTO_t$=LCase(MARCOAGPINTO_t$)
    
    ; Replace the occurrences
    Restore MARCOAGPINTO_data_accents
    Repeat
      
      ; read the data
      Read.s MARCOAGPINTO_before$
      Read.s MARCOAGPINTO_after$
      
      ; ProcedureReturn if end of data
      ; Returns the string in lowercase and without accents
      If MARCOAGPINTO_before$="*"     
        ProcedureReturn MARCOAGPINTO_t$
      EndIf
      
      ; Replace the occurrences
;       MARCOAGPINTO_t$=ReplaceString(MARCOAGPINTO_t$,MARCOAGPINTO_before$,MARCOAGPINTO_after$)
      ReplaceString(MARCOAGPINTO_t$,MARCOAGPINTO_before$,MARCOAGPINTO_after$,#PB_String_InPlace)
      
    ForEver
      
    
    ; Replace the occurrences DATA
    DataSection
      MARCOAGPINTO_data_accents:
      
      ; a
      Data.s "á","a"
      Data.s "à","a"
      Data.s "ä","a"
      Data.s "ã","a"
      Data.s "â","a"
      Data.s "å","a"
      Data.s "ā","a"
      Data.s "æ","a"
      Data.s "ă","a"
      ; b
      Data.s "ḃ","b"
      ; c
      Data.s "ç","c"
      Data.s "č","c"
      Data.s "ċ","c"
      Data.s "ć","c"
      Data.s "ĉ","c"
      ; d
      Data.s "ḋ","d"
      Data.s "đ","d"
      Data.s "ď","d"
      ; e
      Data.s "é","e"
      Data.s "è","e"
      Data.s "ë","e"
      Data.s "ê","e"
      Data.s "ĕ","e"
      Data.s "ē","e"   
      Data.s "ė","e"
      Data.s "ễ","e"
      ; f
      Data.s "ḟ","f"
      ; g
      Data.s "ģ","g"
      Data.s "ğ","g"
      Data.s "ġ","g"
      ; i
      Data.s "í","i"
      Data.s "ì","i"
      Data.s "ï","i"
      Data.s "î","i"
      Data.s "ī","i"      
      ; j
      Data.s "ɉ","j"
      ; l
      Data.s "ƚ","l"      
      Data.s "ł","l"
      Data.s "ľ","l"
      ; m
      Data.s "ṁ","m"
      ; n
      Data.s "ñ","n"
      Data.s "ń","n"
      Data.s "ň","n"
      ; o
      Data.s "ó","o"
      Data.s "ò","o"
      Data.s "ö","o"
      Data.s "õ","o"
      Data.s "ō","o"
      Data.s "ø","o"
      Data.s "ô","o"      
      ; p
      Data.s "ṗ","p"    
      ; r
      Data.s "ř","r"       
      ; s
      Data.s "ṡ","s"
      Data.s "š","s"
      Data.s "ș","s"
      ; t
      Data.s "ṫ","t"
      Data.s "ŧ","t"
      Data.s "ť","t"
      Data.s "ț","t"
      ; u
      Data.s "ú","u"
      Data.s "ù","u"
      Data.s "ü","u"
      Data.s "û","u"
      Data.s "ū","u"
      ; w
      Data.s "ẃ","w"
      Data.s "ẁ","w"
      Data.s "ŵ","w"
      Data.s "ẅ","w"      
      ; y
      Data.s "ў","y"
      Data.s "ý","y"
      Data.s "ỳ","y"
      Data.s "ŷ","y"
      Data.s "ÿ","y"
      ; z
      Data.s "ž","z"
      ; End
      Data.s "*","*"
    EndDataSection      
    
  EndProcedure
  
  
  
  
  ; Darken Image procedure, based on the source code from the PB forum
  ;
  ; Image Number, Darken %
  ;
  ; V1.0 - 01/FEB/2016
  ;
  Procedure DarkenImage(MARCOAGPINTO_image_number,MARCOAGPINTO_darken_percent)
    StartDrawing(ImageOutput(MARCOAGPINTO_image_number))
    DrawingMode(#PB_2DDrawing_AlphaBlend)
    Box(0,0,ImageWidth(MARCOAGPINTO_image_number),ImageHeight(MARCOAGPINTO_image_number),RGBA(0,0,0,2.5*MARCOAGPINTO_darken_percent))     
    StopDrawing()  
  EndProcedure  
  
  
  
  
  ; Returns the maximum of two values, uses natural numbers
  ;
  ; V1.0 - 27/NOV/2019
  ;
  Procedure Max(MARCOAGPINTO_value1,MARCOAGPINTO_value2)
    
    If MARCOAGPINTO_value1>MARCOAGPINTO_value2 : ProcedureReturn MARCOAGPINTO_value1 : EndIf
    
    ProcedureReturn MARCOAGPINTO_value2
    
  EndProcedure
  
  
  
  
  ; Returns the minimum of two values, uses natural numbers
  ;
  ; V1.0 - 27/NOV/2019
  ;
  Procedure Min(MARCOAGPINTO_value1,MARCOAGPINTO_value2)
    
    If MARCOAGPINTO_value1<MARCOAGPINTO_value2 : ProcedureReturn MARCOAGPINTO_value1 : EndIf
    
    ProcedureReturn MARCOAGPINTO_value2
    
  EndProcedure
  
  
  

  ; Place the cursor position in a (MARCOAGPINTO_gadget_type):
  ;    1 = EditorGadget;
  ;    2 = ListIconGadget;
  ;
  ; Help from the PB forum user: mestnyi - https://www.purebasic.fr/english/viewtopic.php?f=13&t=72277
  ;
  ; V1.0 - 13/FEB/2019
  ; V1.1 - 15/JAN/2020
  ;        o Fix: Now in Linux it scrolls to the cursor position
  ; V1.2 - 24/JUN/2021
  ;        o Now supports ListIconGadgets
  ;
  Procedure SetPos(MARCOAGPINTO_gadget,MARCOAGPINTO_position,MARCOAGPINTO_gadget_type)
    
    ; Editor Gadget
    If MARCOAGPINTO_gadget_type=1
      
      CompilerSelect #PB_Compiler_OS
        CompilerCase #PB_OS_Linux
          If GadgetType(MARCOAGPINTO_gadget) = #PB_GadgetType_Editor
            Protected PositionIter.GtkTextIter
            Protected mark, *iter.GtkTextIter
            Protected *buffer = gtk_text_view_get_buffer_(GadgetID(MARCOAGPINTO_gadget))
            gtk_text_buffer_get_iter_at_offset_(*buffer, @PositionIter, MARCOAGPINTO_position)
            gtk_text_buffer_place_cursor_(*buffer, PositionIter)
            mark=gtk_text_buffer_create_mark_(*buffer,"cursor", PositionIter, #False);//create a mark in the buffer to scroll to
            gtk_text_view_scroll_to_mark_(GadgetID(MARCOAGPINTO_gadget),mark,0,#False,0,0) ; //scroll to the mark
            ; gtk_text_view_scroll_to_iter_(GadgetID(MARCOAGPINTO_gadget), PositionIter, 0,#False,0,0)

          Else
            gtk_editable_set_position_( GadgetID(MARCOAGPINTO_gadget), MARCOAGPINTO_position )
          EndIf
     
          CompilerCase #PB_OS_MacOS
            Protected Range.NSRange : Range\location = MARCOAGPINTO_position
            CocoaMessage(0, GadgetID(MARCOAGPINTO_gadget), "setSelectedRange:@", @Range)
            CocoaMessage(0, GadgetID(MARCOAGPINTO_gadget), "scrollRangeToVisible:@", @Range)
       
          CompilerCase #PB_OS_Windows
            SendMessage_(GadgetID(MARCOAGPINTO_gadget), #EM_SETSEL, MARCOAGPINTO_position, MARCOAGPINTO_position)
       
        CompilerEndSelect
        
        ProcedureReturn #True
        
    EndIf
    
    
    ; ListIconGadget
    If MARCOAGPINTO_gadget_type=2
      
      SetGadgetState(MARCOAGPINTO_gadget,MARCOAGPINTO_position)
      ProcedureReturn #True
      
    EndIf
    
  EndProcedure
  
  
  
  ; Place the cursor position in TOP in a (MARCOAGPINTO_gadget_type):
  ;    1 = EditorGadget;
  ;    2 = ListIconGadget;
  ;
  ; Help from the PB forum user: mestnyi - https://www.purebasic.fr/english/viewtopic.php?f=13&t=72277
  ;
  ; V1.0 - 24/JUN/2021
  ;
  Procedure SetPosTop(MARCOAGPINTO_gadget,MARCOAGPINTO_gadget_type)
    
    
    ; Editor Gadget
    If MARCOAGPINTO_gadget_type=1
      
      MARCOAGPINTO_position=1
      
      CompilerSelect #PB_Compiler_OS
        CompilerCase #PB_OS_Linux
          If GadgetType(MARCOAGPINTO_gadget) = #PB_GadgetType_Editor
            Protected PositionIter.GtkTextIter
            Protected mark, *iter.GtkTextIter
            Protected *buffer = gtk_text_view_get_buffer_(GadgetID(MARCOAGPINTO_gadget))
            gtk_text_buffer_get_iter_at_offset_(*buffer, @PositionIter, MARCOAGPINTO_position)
            gtk_text_buffer_place_cursor_(*buffer, PositionIter)
            mark=gtk_text_buffer_create_mark_(*buffer,"cursor", PositionIter, #False);//create a mark in the buffer to scroll to
            gtk_text_view_scroll_to_mark_(GadgetID(MARCOAGPINTO_gadget),mark,0,#False,0,0) ; //scroll to the mark
            ; gtk_text_view_scroll_to_iter_(GadgetID(MARCOAGPINTO_gadget), PositionIter, 0,#False,0,0)

          Else
            gtk_editable_set_position_( GadgetID(MARCOAGPINTO_gadget), MARCOAGPINTO_position )
          EndIf
     
          CompilerCase #PB_OS_MacOS
            Protected Range.NSRange : Range\location = MARCOAGPINTO_position
            CocoaMessage(0, GadgetID(MARCOAGPINTO_gadget), "setSelectedRange:@", @Range)
            CocoaMessage(0, GadgetID(MARCOAGPINTO_gadget), "scrollRangeToVisible:@", @Range)
       
          CompilerCase #PB_OS_Windows
            SendMessage_(GadgetID(MARCOAGPINTO_gadget), #EM_SETSEL, MARCOAGPINTO_position, MARCOAGPINTO_position)
       
        CompilerEndSelect
        
        ProcedureReturn #True
        
    EndIf
    
    
    ; ListIconGadget
    If MARCOAGPINTO_gadget_type=2
      
      MARCOAGPINTO_position=0
      
      SetGadgetState(MARCOAGPINTO_gadget,MARCOAGPINTO_position)
      ProcedureReturn #True
      
    EndIf
    
  EndProcedure
  
  
  
  
  ; Place the cursor position in BOTTOM in a (MARCOAGPINTO_gadget_type):
  ;    1 = EditorGadget;
  ;    2 = ListIconGadget;
  ;
  ; Help from the PB forum user: mestnyi - https://www.purebasic.fr/english/viewtopic.php?f=13&t=72277
  ;
  ; V1.0 - 24/JUN/2021
  ;
  Procedure SetPosBottom(MARCOAGPINTO_gadget,MARCOAGPINTO_gadget_type)
    
    ; Editor Gadget
    If MARCOAGPINTO_gadget_type=1
      
      MARCOAGPINTO_position=Len(GetGadgetText(MARCOAGPINTO_gadget))
      
      CompilerSelect #PB_Compiler_OS
        CompilerCase #PB_OS_Linux
          If GadgetType(MARCOAGPINTO_gadget) = #PB_GadgetType_Editor
            Protected PositionIter.GtkTextIter
            Protected mark, *iter.GtkTextIter
            Protected *buffer = gtk_text_view_get_buffer_(GadgetID(MARCOAGPINTO_gadget))
            gtk_text_buffer_get_iter_at_offset_(*buffer, @PositionIter, MARCOAGPINTO_position)
            gtk_text_buffer_place_cursor_(*buffer, PositionIter)
            mark=gtk_text_buffer_create_mark_(*buffer,"cursor", PositionIter, #False);//create a mark in the buffer to scroll to
            gtk_text_view_scroll_to_mark_(GadgetID(MARCOAGPINTO_gadget),mark,0,#False,0,0) ; //scroll to the mark
            ; gtk_text_view_scroll_to_iter_(GadgetID(MARCOAGPINTO_gadget), PositionIter, 0,#False,0,0)

          Else
            gtk_editable_set_position_( GadgetID(MARCOAGPINTO_gadget), MARCOAGPINTO_position )
          EndIf
     
          CompilerCase #PB_OS_MacOS
            Protected Range.NSRange : Range\location = MARCOAGPINTO_position
            CocoaMessage(0, GadgetID(MARCOAGPINTO_gadget), "setSelectedRange:@", @Range)
            CocoaMessage(0, GadgetID(MARCOAGPINTO_gadget), "scrollRangeToVisible:@", @Range)
       
          CompilerCase #PB_OS_Windows
            SendMessage_(GadgetID(MARCOAGPINTO_gadget), #EM_SETSEL, MARCOAGPINTO_position, MARCOAGPINTO_position)
       
        CompilerEndSelect
        
        ProcedureReturn #True
        
    EndIf
    
    
    ; ListIconGadget
    If MARCOAGPINTO_gadget_type=2
      
      MARCOAGPINTO_position=CountGadgetItems(MARCOAGPINTO_gadget)-1
      
      SetGadgetState(MARCOAGPINTO_gadget,MARCOAGPINTO_position)
      ProcedureReturn #True
      
    EndIf
    
  EndProcedure  
  
  
  
  
  ; Gets just the filemane from the path
  ;
  ; Returns a custom string if there is no filenames.
  ;
  ; V1.0 - 26/FEB/2020
  ; V1.1 - 14/JAN/2024
  ;        o Used GetFilePart(MARCOAGPINTO_filename$)
  ;
  Procedure.s GetOnlyFilename(MARCOAGPINTO_filename$,MARCOAGPINTO_return_if_blank_filename$)
    
    MARCOAGPINTO_a$=GetFilePart(MARCOAGPINTO_filename$)
    
    If MARCOAGPINTO_a$="" : MARCOAGPINTO_a$=MARCOAGPINTO_return_if_blank_filename$ : EndIf
    
    ProcedureReturn MARCOAGPINTO_a$
    
  EndProcedure  
  
  
  
  
  ; Gets just the path from the full path+filename
  ;
  ; Returns a custom string if there is no paths.
  ;
  ; V1.0 - 14/JAN/2024
  ;
  Procedure.s GetOnlyPath(MARCOAGPINTO_filename$,MARCOAGPINTO_return_if_blank_filename$)
    
    MARCOAGPINTO_a$=GetPathPart(MARCOAGPINTO_filename$)
    
    If MARCOAGPINTO_a$="" : MARCOAGPINTO_a$=MARCOAGPINTO_return_if_blank_filename$ : EndIf
    
    ProcedureReturn MARCOAGPINTO_a$
    
  EndProcedure  
  

  
  
  ; Force refresh of the asterisk while holding down CURS UP/DOWN
  ;
  ; By the forum user: wombats
  ;
  ; V1.0 - 28/JUL/2018
  ;
  Procedure GadgetRefresh(MARCOAGPINTO_gadget)
    
    CompilerSelect #PB_Compiler_OS

      CompilerCase #PB_OS_Windows
        UpdateWindow_(GadgetID(MARCOAGPINTO_gadget))

      CompilerCase #PB_OS_Linux
        CompilerIf Subsystem("qt")
          QtScript("gadget(" + Str(MARCOAGPINTO_gadget) + ").repaint()")
        CompilerElse
          gtk_widget_queue_draw_(GadgetID(MARCOAGPINTO_gadget))
        CompilerEndIf

      CompilerCase #PB_OS_MacOS
        CocoaMessage(0, GadgetID(MARCOAGPINTO_gadget), "setNeedsDisplay:", 1)

    CompilerEndSelect
 
  EndProcedure  
  
  
  
  
  ; Force refresh of the asterisk while holding down CURS UP/DOWN
  ;
  ; Suggested in the forum on: 13/FEB/2023
  ;
  ; Replaces the old Procedure which is kept here only until it is proven that this works 100%.
  ;
  ; V1.0 - 13/FEB/2023
  ;
  Procedure GadgetsRefresh()
    
    While WindowEvent() : Wend
 
  EndProcedure  
  
  
  
  
  ; To replace a chr in a string at a given position
  ;
  ; V1.0 - 23/APR/2018
  ;
  Procedure.s ReplaceChrInString(MARCOAGPINTO_t$,MARCOAGPINTO_chr$,MARCOAGPINTO_position)
  
    MARCOAGPINTO_left_t$=""
    MARCOAGPINTO_right_t$=""
    If MARCOAGPINTO_position>1 : MARCOAGPINTO_left_t$=Left(MARCOAGPINTO_t$,MARCOAGPINTO_position-1) : EndIf
    If MARCOAGPINTO_position<>Len(MARCOAGPINTO_t$) : MARCOAGPINTO_right_t$=Mid(MARCOAGPINTO_t$,MARCOAGPINTO_position+1) : EndIf
  
    ProcedureReturn MARCOAGPINTO_left_t$+MARCOAGPINTO_chr$+MARCOAGPINTO_right_t$
  
  EndProcedure
  
  
  
  
  ; Created a Procedure InvalidValue(current_window, current_gadget,min_value.f,max_value.f,error_message$,flag)
  ; which returns #True If the values don't match, disabling the current_window and setting focus to
  ; the current_gadget.  
  ;
  ; Added a FLAG variable, which if it is #True, it exits the procedure with #False, to avoid warning to
  ; every invalid field, because the initial condition is:
  ; IF INVALID=TRUE AND FLAG=FALSE THEN BLAH BLAH
  ;
  ; An easier way to valdate fields either in stringgadgets or spingadgets
  ;
  ; V1.0 - 14/SEP/2015
  ; V1.1 - 06/JAN/2017
  ;        o The Procedure that checks For invalid values now uses floats
  ; V1.2 - 01/DEC/2017
  ;        o Message Requesters now have a sign.  
  ; V1.3 - 04/APR/2020
  ;        o cleaned the code
  ; V1.4 - 04/APR/2021
  ;        o If gadget is empty it changes its get value to MARCOAGPINTO_value.f-1
  ; V1.5 - 06/APR/2021
  ;        07/APR/2021
  ;        18/APR/2021
  ;        19/APR/2021
  ;        o Improved the invalid values datection
  ;
  Procedure InvalidValue(MARCOAGPINTO_current_gadget,MARCOAGPINTO_min_value.f,MARCOAGPINTO_max_value.f,MARCOAGPINTO_error_message$,MARCOAGPINTO_flag)
    
    If MARCOAGPINTO_flag=#True : ProcedureReturn #False : EndIf ;To avoid warning for every wrong field on the window
    
    MARCOAGPINTO_string$=GetGadgetText(MARCOAGPINTO_current_gadget)
    MARCOAGPINTO_value.f=ValF(MARCOAGPINTO_string$)

    ; Change value to MARCOAGPINTO_min_value.f-1 if gadget blank or invalid
    If Right(MARCOAGPINTO_string$,1)="-" Or Right(MARCOAGPINTO_string$,1)="." Or (FindString(MARCOAGPINTO_string$,"-")>0 And Left(MARCOAGPINTO_string$,1)<>"-") Or (FindString(MARCOAGPINTO_string$,".")>0 And Left(MARCOAGPINTO_string$,1)=".")
      MARCOAGPINTO_value.f=MARCOAGPINTO_min_value.f-1
    EndIf
    If Len(MARCOAGPINTO_string$)=0
      MARCOAGPINTO_value.f=MARCOAGPINTO_min_value.f-1
    ElseIf CountString(MARCOAGPINTO_string$,"-")>1 Or CountString(MARCOAGPINTO_string$,".")>1
      MARCOAGPINTO_value.f=MARCOAGPINTO_min_value.f-1
    Else
      For MARCOAGPINTO_f=1 To Len(MARCOAGPINTO_string$)
        MARCOAGPINTO_t$=Mid(MARCOAGPINTO_string$,MARCOAGPINTO_f,1)
        If (MARCOAGPINTO_t$<"0" Or MARCOAGPINTO_t$>"9") And MARCOAGPINTO_t$<>"-" And MARCOAGPINTO_t$<>"."
          MARCOAGPINTO_value.f=MARCOAGPINTO_min_value.f-1
          Break
        EndIf        
      Next MARCOAGPINTO_f
    EndIf
    
    If MARCOAGPINTO_value.f<MARCOAGPINTO_min_value.f Or MARCOAGPINTO_value.f>MARCOAGPINTO_max_value.f
      MessageRequester("Warning!",MARCOAGPINTO_error_message$,#PB_MessageRequester_Warning)
      SetActiveGadget(MARCOAGPINTO_current_gadget)
      ProcedureReturn #True      
    EndIf
    
    ProcedureReturn #False
    
  EndProcedure
  
  
  
  
  ; It returns a string with the filesize in bytes/kB/MB/GB like: "(10.4 MB)"
  ; Added a label, for example for Proofing Tool GUI: "(aff:1 MB)"
  ;
  ; V1.0 - 02/DEC/2020
  ; V1.1 - 01/JUL/2021
  ;        o Added a file label
  ;        o Removed variable by using direct ProcedureReturn
  ; V1.2 - 03/JUL/2021
  ;        o It now allows brackets on/off
  ;
  Procedure.s ShowFileSizeFormatted(MARCOAGPINTO_file_label$,MARCOAGPINTO_file_size_in_bytes,MARCOAGPINTO_brackets_on)
    
    ; Brackets on/off
    MARCOAGPINTO_brackets_left$="("
    MARCOAGPINTO_brackets_right$=")"
    If MARCOAGPINTO_brackets_on=#False
      MARCOAGPINTO_brackets_left$=""
      MARCOAGPINTO_brackets_right$=""
    EndIf
    
    ; Bytes
    If MARCOAGPINTO_file_size_in_bytes<1024
      ProcedureReturn MARCOAGPINTO_brackets_left$+MARCOAGPINTO_file_label$+Str(MARCOAGPINTO_file_size_in_bytes)+" bytes"+MARCOAGPINTO_brackets_right$
      
    ; kB  
    ElseIf MARCOAGPINTO_file_size_in_bytes>=1024 And MARCOAGPINTO_file_size_in_bytes<1024*1024
      ProcedureReturn MARCOAGPINTO_brackets_left$+MARCOAGPINTO_file_label$+StrF(MARCOAGPINTO_file_size_in_bytes/1024,1)+" kB"+MARCOAGPINTO_brackets_right$
      
    ; MB  
    ElseIf MARCOAGPINTO_file_size_in_bytes>=1024*1024 And MARCOAGPINTO_file_size_in_bytes<1024*1024*1024
      ProcedureReturn MARCOAGPINTO_brackets_left$+MARCOAGPINTO_file_label$+StrF(MARCOAGPINTO_file_size_in_bytes/1024/1024,1)+" MB"+MARCOAGPINTO_brackets_right$
      
    ; GB  
    ElseIf MARCOAGPINTO_file_size_in_bytes>=1024*1024*1024
      ProcedureReturn MARCOAGPINTO_brackets_left$+MARCOAGPINTO_file_label$+StrF(MARCOAGPINTO_file_size_in_bytes/1024/1024/1024,1)+" GB"+MARCOAGPINTO_brackets_right$
      
    EndIf
    
  EndProcedure




; To extract a string between quotes,
; only works with ' and "
;
; Returns empty if the string doesn't start with a valid quote chr.
;
; V1.0 - 28/DEC/2020
;
Procedure.s ExtractStringFromQuotes(MARCOAGPINTO_t$, MARCOAGPINTO_pos_start)
  
  MARCOAGPINTO_pos$=Mid(MARCOAGPINTO_t$,MARCOAGPINTO_pos_start,1)
  If MARCOAGPINTO_pos$<>"'" And MARCOAGPINTO_pos$<>Chr(34) : ProcedureReturn "" : EndIf
  
  MARCOAGPINTO_pos_start+1
  MARCOAGPINTO_t=FindString(MARCOAGPINTO_t$,MARCOAGPINTO_pos$,MARCOAGPINTO_pos_start)
  If MARCOAGPINTO_t=0 : ProcedureReturn "" : EndIf
  
  ProcedureReturn Mid(MARCOAGPINTO_t$,MARCOAGPINTO_pos_start,MARCOAGPINTO_t-MARCOAGPINTO_pos_start)
  
EndProcedure




; To place text and state in a SpinGadget
;
; Use with integers.
;
; If the value in the gadget matches the value to place, it procedure returns.
;
; V1.0 - 10/MAY/2021
; V1.1 - 30/JUN/2023
;        o If the value in the gadget matches the value to place, it procedure returns
;
Procedure SetGadgetTextState(MARCOAGPINTO_gadget, MARCOAGPINTO_value)
  
  ; If the value in the gadget matches the value to place, it procedure returns - 30/JUN/2023
  If GetGadgetText(MARCOAGPINTO_gadget)=Str(GetGadgetState(MARCOAGPINTO_gadget)) And MARCOAGPINTO_value=GetGadgetState(MARCOAGPINTO_gadget) : ProcedureReturn #False : EndIf
  
  SetGadgetText(MARCOAGPINTO_gadget,Str(MARCOAGPINTO_value))
  SetGadgetState(MARCOAGPINTO_gadget,MARCOAGPINTO_value)
  
EndProcedure




; To toggle (xor) #True and #False for ListIconGadgets with checkboxes in the lines
;
; input: 0/#False or 1/#True
; Output: 0 or 1
;
; V1.0 - 26/JUN/2021
; V1.1 - 27/JUN/2021
;        o Optimised/Cleaned the code
;
Procedure ToggleTrueFalse(MARCOAGPINTO_boolean)
  
  ProcedureReturn 1-MARCOAGPINTO_boolean
  
EndProcedure




; To get the spaces in a string.
;
; It returns a string with 4 characters, zeros or ones, for:
;   1st - Found left space
;   2nd - Found right space
;   3rd - Found middle space
;   4th - Found two or more spaces in sequence
;
; or returns "2" if length of string<=2
;
; V1.0 - 15/JUL/2021
;
Procedure.s CheckSpacesInString(MARCOAGPINTO_t$)
  
  ; Length <=2
  If Len(MARCOAGPINTO_t$)<=2 : ProcedureReturn "2" : EndIf
  
  
  ; String that is returned by the procedure
  MARCOAGPINTO_results_to_return$=""
  
  
  ; Left space
  MARCOAGPINTO_to_add$="0"
  If Left(MARCOAGPINTO_t$,1)=" " : MARCOAGPINTO_to_add$="1" : EndIf
  MARCOAGPINTO_results_to_return$+MARCOAGPINTO_to_add$
  
  
  ; Right space
  MARCOAGPINTO_to_add$="0"
  If Right(MARCOAGPINTO_t$,1)=" " : MARCOAGPINTO_to_add$="1" : EndIf
  MARCOAGPINTO_results_to_return$+MARCOAGPINTO_to_add$

  
  ; Middle space - it doesn't count with right space
  MARCOAGPINTO_to_add$="0"
  MARCOAGPINTO_found_middle_string_position=FindString(MARCOAGPINTO_t$," ",2)
  If  MARCOAGPINTO_found_middle_string_position>0 And MARCOAGPINTO_found_middle_string_position<>Len(MARCOAGPINTO_t$) : MARCOAGPINTO_to_add$="1" : EndIf
  MARCOAGPINTO_results_to_return$+MARCOAGPINTO_to_add$
  
  
  ; Two or more spaces in sequence
  MARCOAGPINTO_to_add$="0"
  If FindString(MARCOAGPINTO_t$,"  ") : MARCOAGPINTO_to_add$="1" : EndIf
  MARCOAGPINTO_results_to_return$+MARCOAGPINTO_to_add$    
  
  
  ; Returns the results
  ProcedureReturn MARCOAGPINTO_results_to_return$
  
EndProcedure




; To clear the text of a gadget, basically SpinGadgets, StringGadgets and EditorGadgets.
;
; This procedure reduces the complexity of the code by avoid using SetGadgetText(gadget,"").
;
; V1.0 - 15/JUL/2021
;
Procedure ClearGadgetText(MARCOAGPINTO_gadget)
  
  SetGadgetText(MARCOAGPINTO_gadget,"")
  
EndProcedure




; To calculate factorials.
; Returns a quad value.
;
; V1.0 - 01/NOV/2021
; V1.1 - 02/NOV/2021
;        o Fixed 0!=0, it should be=1
;
Procedure.d factorial(MARCOAGPINTO_n)
  
  ; If value invalid (<1)
  If MARCOAGPINTO_n<0 : ProcedureReturn 0 : EndIf
  
  ; If value=1 or =0
  If MARCOAGPINTO_n=1 Or MARCOAGPINTO_n=0 : ProcedureReturn 1 : EndIf
  
  MARCOAGPINTO_VALUE.d=MARCOAGPINTO_n
  
  For MARCOAGPINTO_f=MARCOAGPINTO_n-1 To 1 Step -1
    MARCOAGPINTO_VALUE.d*MARCOAGPINTO_f
  Next MARCOAGPINTO_f
  
  ; Return the quad of the factorial
  ProcedureReturn MARCOAGPINTO_VALUE.d
  
EndProcedure




; Converts milliseconds to a string (time taken)
; 
; Returns a string
;
; V1.0 - 21/NOV/2021
;
Procedure.s TimeToString(MARCOAGPINTO_label$,MARCOAGPINTO_milliseconds_taken)
        
        MARCOAGPINTO_seconds_taken=MARCOAGPINTO_milliseconds_taken/1000
          

        MARCOAGPINTO_t$=Str(MARCOAGPINTO_seconds_taken/86400)+FormatDate("d%hhh%iim%sss", MARCOAGPINTO_seconds_taken % 86400)
        If Left(MARCOAGPINTO_t$,5)="0d00h" : MARCOAGPINTO_t$=Mid(MARCOAGPINTO_t$,6,6) : EndIf
        If Left(MARCOAGPINTO_t$,2)="0d" : MARCOAGPINTO_t$=Mid(MARCOAGPINTO_t$,3,9) : EndIf
        If Left(MARCOAGPINTO_t$,3)="00h" : MARCOAGPINTO_t$=Mid(MARCOAGPINTO_t$,4,6) : EndIf
                
        ProcedureReturn MARCOAGPINTO_label$+MARCOAGPINTO_t$
        
EndProcedure




; Turns a StringGadget to #Red if content is blank (for example, all spaces or null)
;
; V1.0 - 11/DEC/2021
;
Procedure RedIfStringBlank(MARCOAGPINTO_gadget)
  
  MARCOAGPINTO_string$=Trim(GetGadgetText(MARCOAGPINTO_gadget))
  MARCOAGPINTO_gadget_colour=GetGadgetColor(MARCOAGPINTO_gadget,#PB_Gadget_BackColor)
  
  If MARCOAGPINTO_string$<>"" And MARCOAGPINTO_gadget_colour<>-1
    SetGadgetColor(MARCOAGPINTO_gadget,#PB_Gadget_BackColor,-1)
    ProcedureReturn
  EndIf
  
  If MARCOAGPINTO_string$="" And MARCOAGPINTO_gadget_colour<>#Red
    SetGadgetColor(MARCOAGPINTO_gadget,#PB_Gadget_BackColor,#Red)
    ProcedureReturn
  EndIf 
  
EndProcedure




; Maximises the last column of a ListIconGadget for the use o virtual vertical bars
;
; Used in Proofing Tool GUI.
;
; It uses the width of the window + 40
;
; V1.0 - 10/FEB/2022
;
Procedure MaximiseLastColumnListIconGadget(MARCOAGPINTO_gadget,MARCOAGPINTO_window)
  
  ; Get the size of window + 40 pixels
  MARCOAGPINTO_size_window_plus_40=WindowWidth(MARCOAGPINTO_window)+40
  
  ; Get last column (number of columns MINUS one)
  MARCOAGPINTO_number_columns=GetGadgetAttribute(MARCOAGPINTO_gadget,#PB_ListIcon_ColumnCount)-1
  
  ; Get last column size
  MARCOAGPINTO_size_last_column=GetGadgetItemAttribute(MARCOAGPINTO_gadget,0,#PB_ListIcon_ColumnWidth,MARCOAGPINTO_number_columns)
  
  ; No changes in column size
  If MARCOAGPINTO_size_last_column>=MARCOAGPINTO_size_window_plus_40
    ProcedureReturn
  EndIf
  
  ; Resize last column
  SetGadgetItemAttribute(MARCOAGPINTO_gadget,0,#PB_ListIcon_ColumnWidth,MARCOAGPINTO_size_window_plus_40,MARCOAGPINTO_number_columns)
  
EndProcedure




; Gets the centered X position of a gadget
; Used for centering gadgets on windows.
;
; V1.0 - 30/JUL/2022
;
Procedure GetCentreX(MARCOAGPINTO_target_width,MARCOAGPINTO_gadget_width)
  
  MARCOAGPINTO_x=MARCOAGPINTO_target_width/2 - MARCOAGPINTO_gadget_width/2
  
  ProcedureReturn MARCOAGPINTO_x
  
EndProcedure




; Gets the centered Y position of a gadget
; Used for centering gadgets on windows.
;
; V1.0 - 30/JUL/2022
;
Procedure GetCentreY(MARCOAGPINTO_target_height,MARCOAGPINTO_gadget_height)
  
  MARCOAGPINTO_y=MARCOAGPINTO_target_height/2 - MARCOAGPINTO_gadget_height/2
  
  ProcedureReturn MARCOAGPINTO_y
  
EndProcedure




; Gets the maximum size a window can become in the desktop.
; (width)
;
; It opens an invisible full desktop window to find the value.
;
; V1.0 - 14/AUG/2022
;
Procedure GetMaxWindowDesktopWidth()
 
    MARCOAGPINTO_dynamic_value_for_window=3000
  
    If OpenWindow(MARCOAGPINTO_dynamic_value_for_window,0,0,10,10,"Getting Maximum Window Size",#PB_Window_Maximize|#PB_Window_Invisible)=0 : MessageRequester("Error", "Can't open a window.",#PB_MessageRequester_Error) : EndIf
      MARCOAGPINTO_max_width=WindowWidth(MARCOAGPINTO_dynamic_value_for_window)
    CloseWindow(MARCOAGPINTO_dynamic_value_for_window)  
  
    ProcedureReturn MARCOAGPINTO_max_width
    
EndProcedure




; Gets the maximum size a window can become in the desktop.
; (height)
;
; It opens an invisible full desktop window to find the value.
;
; V1.0 - 14/AUG/2022
;
Procedure GetMaxWindowDesktopHeight()
  
    MARCOAGPINTO_dynamic_value_for_window=3000
  
    If OpenWindow(MARCOAGPINTO_dynamic_value_for_window,0,0,10,10,"Getting Maximum Window Size",#PB_Window_Maximize|#PB_Window_Invisible)=0 : MessageRequester("Error", "Can't open a window.",#PB_MessageRequester_Error) : EndIf
      MARCOAGPINTO_max_height=WindowHeight(MARCOAGPINTO_dynamic_value_for_window)
    CloseWindow(MARCOAGPINTO_dynamic_value_for_window)  
    
    ProcedureReturn MARCOAGPINTO_max_height
  
EndProcedure




; Removes all repeated spaces on a string, including individual/repeated ones in the left + right of the string
;
; V1.0 - 13/NOV/2022
;        29/DEC/2022
;
Procedure.s TrimStringAll(MARCOAGPINTO_t$)
  
  ; Remove spaces on left + right of string
  MARCOAGPINTO_t$=Trim(MARCOAGPINTO_t$)
  If MARCOAGPINTO_t$="" : ProcedureReturn MARCOAGPINTO_t$ : EndIf
  
  ; Remove 4 repeated spaces - 29/DEC/2022
  MARCOAGPINTO_t$=ReplaceString(MARCOAGPINTO_t$,"    "," ")
  
  ; Remove 3 repeated spaces - 29/DEC/2022
  MARCOAGPINTO_t$=ReplaceString(MARCOAGPINTO_t$,"   "," ")
  
  ; Remove 2 repeated spaces
  Repeat
    MARCOAGPINTO_t$=ReplaceString(MARCOAGPINTO_t$,"  "," ")
  Until FindString(MARCOAGPINTO_t$,"  ")=0
  
  ; Return the string without repeated spaces
  ProcedureReturn MARCOAGPINTO_t$
  
EndProcedure




; Converts the current position of a range into a % (nnn.nn)
; 2 decimal houses
; symbol (with examples):
;   0= " 20.04%"
;   1= " (20.04%)"
;   2= " [20.04%]"
;
; Notice: It adds a space before the string returned.
;
; V1.0 - 27/DEC/2022
;
Procedure.s ConvertProgressToPercentage(MARCOAGPINTO_current_position.l,MARCOAGPINTO_max_position.l,MARCOAGPINTO_symbols_to_use.l)
  
  ; Symbol to use
  MARCOAGPINTO_symbol_left$=""
  MARCOAGPINTO_symbol_right$=""
  If MARCOAGPINTO_symbols_to_use=1
    MARCOAGPINTO_symbol_left$="("
    MARCOAGPINTO_symbol_right$=")"
  EndIf
  If MARCOAGPINTO_symbols_to_use=2
    MARCOAGPINTO_symbol_left$="["
    MARCOAGPINTO_symbol_right$="]"
  EndIf
  
  ; convert position StrF
  MARCOAGPINTO_value$=StrF((MARCOAGPINTO_current_position*100)/MARCOAGPINTO_max_position,2)
  If Right(MARCOAGPINTO_value$,3)=".00" : MARCOAGPINTO_value$=StringField(MARCOAGPINTO_value$,1,".") : EndIf
  
  ; Place the symbol to use
  MARCOAGPINTO_value$=" "+MARCOAGPINTO_symbol_left$+MARCOAGPINTO_value$+"%"+MARCOAGPINTO_symbol_right$
  
  ; Return the string
  ProcedureReturn MARCOAGPINTO_value$
  
EndProcedure




; Enhanced save file requester to make the source-code smaller.
;
; Example of normal requester:
;  file$=SaveFileRequester("Save Dictionary","","Dictionary (*.dic)|*.dic",0)
;
; Example of ENHANCED requester:
;  file$=FileRequesterSaveEnhanced("Save Dictionary","","Dictionary (*.dic)|*.dic",".dic")
;
; Now it accepts multiple _file_extension$ separated with "|" and the default one if none is typed is at the last parameter MARCOAGPINTO_file_extension$;
;  file$=FileRequesterSaveEnhanced("Save Text File","","Text file (*.txt) | *.txt | XML file (*.xml) | *.xml",".txt")
;
; It returns "" if aborted, or !="" if a filename chosen
;
; V1.0 - 19/JUN/2023
; V1.1 - 20/JUN/2023
;        o It now parses the default_file$
; V1.2 - 23/JUN/2023
;        o Now it accepts multiple file patterns$ with a default file_extension$ if none is typed
;
Procedure.s SaveFileRequesterEnhanced(MARCOAGPINTO_title$,MARCOAGPINTO_default_file$,MARCOAGPINTO_pattern$,MARCOAGPINTO_file_extension$)
  
  ; Parse if the MARCOAGPINTO_default_file$ contains a path, to just get the filename
  If MARCOAGPINTO_default_file$<>""
    If FindString(MARCOAGPINTO_default_file$,"/") Or FindString(MARCOAGPINTO_default_file$,"\")
      ReplaceString(MARCOAGPINTO_default_file$,"\","/",#PB_String_InPlace)
      MARCOAGPINTO_counter=CountString(MARCOAGPINTO_default_file$,"/")
      MARCOAGPINTO_default_file$=StringField(MARCOAGPINTO_default_file$,MARCOAGPINTO_counter+1,"/")
    EndIf
  EndIf
  
  ; Open File selector   
  MARCOAGPINTO_file$=SaveFileRequester(MARCOAGPINTO_title$,MARCOAGPINTO_default_file$, MARCOAGPINTO_pattern$, 0)
      
  ; Blank file (no filename selected)
  If MARCOAGPINTO_file$="" : ProcedureReturn "" : EndIf
      
  ; Add the extension to the file
  If CountString(MARCOAGPINTO_pattern$,"(*")>1
    MARCOAGPINTO_use_default_extension=#True
    MARCOAGPINTO_position_start=FindString(MARCOAGPINTO_pattern$,"(*")+1
    For MARCOAGPINTO_f=1 To CountString(MARCOAGPINTO_pattern$,"(*")
      MARCOAGPINTO_position_end=FindString(MARCOAGPINTO_pattern$,")",MARCOAGPINTO_position_start+1)
      MARCOAGPINTO_current_ext$=Mid(MARCOAGPINTO_pattern$,MARCOAGPINTO_position_start+1,MARCOAGPINTO_position_end-MARCOAGPINTO_position_start-1)
      If LCase(Right(MARCOAGPINTO_file$,Len(MARCOAGPINTO_current_ext$)))=LCase(MARCOAGPINTO_current_ext$)
        MARCOAGPINTO_use_default_extension=#False
        Break
      EndIf
      MARCOAGPINTO_position_start=FindString(MARCOAGPINTO_pattern$,"(*",MARCOAGPINTO_position_end+1)+1
    Next MARCOAGPINTO_f
    If MARCOAGPINTO_use_default_extension=#True : MARCOAGPINTO_file$+MARCOAGPINTO_file_extension$: EndIf
  Else
    If LCase(Right(MARCOAGPINTO_file$,Len(MARCOAGPINTO_file_extension$)))<>LCase(MARCOAGPINTO_file_extension$) : MARCOAGPINTO_file$+MARCOAGPINTO_file_extension$: EndIf
  EndIf
      
  ; If file exists, ask to confirm overwriting it
  If FileSize(MARCOAGPINTO_file$)>=0
    If MessageRequester("Warning!","File already exists! Overwrite it?",#PB_MessageRequester_YesNo|#PB_MessageRequester_Warning)=#PB_MessageRequester_No
      ProcedureReturn ""
    EndIf
    DeleteFile(MARCOAGPINTO_file$) ;delete the existing file
  EndIf      
      
  ; Return the filename
  ProcedureReturn MARCOAGPINTO_file$
      
EndProcedure




; Checks if a file exists after opening it with the OpenFileRequester()
;
; MARCOAGPINTO_file_extension$ does nothing, the idea is to add an extension if it isn't there.
;
; Returns #True or #False and if #False it shows the error message.
;
;
; V1.0 - 02/JUL/2023
;
Procedure IsFileExist(MARCOAGPINTO_file$,MARCOAGPINTO_file_extension$,MARCOAGPINTO_error_message$)
    
  If FileSize(MARCOAGPINTO_file$)<=0
    MessageRequester("Error",MARCOAGPINTO_error_message$,#PB_MessageRequester_Warning)
    ProcedureReturn #False
  EndIf
  
  ; File exists
  ProcedureReturn #True
  
EndProcedure




; Places a ButtonGadget AT (x,y) with distance from the (x,y) and tooltip, etc.
;
; 10/NOV/2023: Swapped 1 with 2
;
;  1. x,y
;  2. Gadget Target (button)
;  3. Gadget Target Width
;  4. Gadget Target Height
;  5. Text
;  6. Add X pixels (negative removes)
;  7. Add Y pixels (negative removes)
;  8. Tooltip
;  9. Disable button Gadget (#True/#False)
;
; V1.0 - 12/JAN/2024
;
Procedure PlaceButtonGadgetAtXY(MARCOAGPINTO_gadget_target,MARCOAGPINTO_x,MARCOAGPINTO_y,MARCOAGPINTO_width,MARCOAGPINTO_height,MARCOAGPINTO_text$,MARCOAGPINTO_add_x_pixels,MARCOAGPINTO_add_y_pixels,MARCOAGPINTO_tooltip$,MARCOAGPINTO_disabled)
  
  MARCOAGPINTO_x+MARCOAGPINTO_add_x_pixels
  MARCOAGPINTO_y+MARCOAGPINTO_add_y_pixels
  
  ButtonGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_x,MARCOAGPINTO_y,MARCOAGPINTO_width,MARCOAGPINTO_height,MARCOAGPINTO_text$)
  DisableGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_disabled)
  If MARCOAGPINTO_tooltip$<>""
;     MARCOAGPINTO_tooltip$=ReplaceString(MARCOAGPINTO_tooltip$,". ","."+#LF$+#LF$)
    GadgetToolTip(MARCOAGPINTO_gadget_target,MARCOAGPINTO_tooltip$)
  EndIf
  
EndProcedure




; Places a ButtonGadget AFTER a gadget with distance from the gadget and tooltip, etc.
;
;
; 10/NOV/2023: Swapped 1 with 2
;
;  1. Gadget Source
;  2. Gadget Target (button)
;  3. Gadget Target Width
;  4. Gadget Target Height
;  5. Text
;  6. Add X pixels (negative removes)
;  7. Add Y pixels (negative removes)
;  8. Tooltip
;  9. Disable button Gadget (#True/#False)
;
; V1.0 - 21/OCT/2023
; V1.1 - 08/NOV/2023
;        o Tooltip now uses paragraphs if it finds ". "
;
Procedure PlaceButtonGadgetAfterGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_gadget_source,MARCOAGPINTO_width,MARCOAGPINTO_height,MARCOAGPINTO_text$,MARCOAGPINTO_add_x_pixels,MARCOAGPINTO_add_y_pixels,MARCOAGPINTO_tooltip$,MARCOAGPINTO_disabled)
  
  MARCOAGPINTO_x=GadgetX(MARCOAGPINTO_gadget_source)+MARCOAGPINTO_add_x_pixels
  MARCOAGPINTO_y=GadgetY(MARCOAGPINTO_gadget_source)+MARCOAGPINTO_add_y_pixels
  MARCOAGPINTO_x+GadgetWidth(MARCOAGPINTO_gadget_source)
  
  ButtonGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_x,MARCOAGPINTO_y,MARCOAGPINTO_width,MARCOAGPINTO_height,MARCOAGPINTO_text$)
  DisableGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_disabled)
  If MARCOAGPINTO_tooltip$<>""
;     MARCOAGPINTO_tooltip$=ReplaceString(MARCOAGPINTO_tooltip$,". ","."+#LF$+#LF$)
    GadgetToolTip(MARCOAGPINTO_gadget_target,MARCOAGPINTO_tooltip$)
  EndIf
  
EndProcedure




; Places a ButtonGadget BEFORE a gadget with distance from the gadget and tooltip, etc.
;
;
; 10/NOV/2023: Swapped 1 with 2
;
;  1. Gadget Source
;  2. Gadget Target (button)
;  3. Gadget Target Width
;  4. Gadget Target Height
;  5. Text
;  6. Add X pixels (negative removes)
;  7. Add Y pixels (negative removes)
;  8. Tooltip
;  9. Disable button Gadget (#True/#False)
;
; V1.0 - 21/OCT/2023
; V1.1 - 08/NOV/2023
;        o Tooltip now uses paragraphs if it finds ". "
;
Procedure PlaceButtonGadgetBeforeGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_gadget_source,MARCOAGPINTO_width,MARCOAGPINTO_height,MARCOAGPINTO_text$,MARCOAGPINTO_add_x_pixels,MARCOAGPINTO_add_y_pixels,MARCOAGPINTO_tooltip$,MARCOAGPINTO_disabled)
  
  MARCOAGPINTO_x=GadgetX(MARCOAGPINTO_gadget_source)-MARCOAGPINTO_add_x_pixels
  MARCOAGPINTO_y=GadgetY(MARCOAGPINTO_gadget_source)+MARCOAGPINTO_add_y_pixels
  MARCOAGPINTO_x-GadgetWidth(MARCOAGPINTO_gadget_source)
  
  ButtonGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_x,MARCOAGPINTO_y,MARCOAGPINTO_width,MARCOAGPINTO_height,MARCOAGPINTO_text$)
  DisableGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_disabled)
  If MARCOAGPINTO_tooltip$<>""
;     MARCOAGPINTO_tooltip$=ReplaceString(MARCOAGPINTO_tooltip$,". ","."+#LF$+#LF$)
    GadgetToolTip(MARCOAGPINTO_gadget_target,MARCOAGPINTO_tooltip$)
  EndIf
  
EndProcedure




; Places an image AT (x,y) with distance from the (x,y) and tooltip, etc.
;
; 10/NOV/2023: Swapped 1 with 2
;
;  1. x,y
;  2. Gadget Target (image)
;  3. Image ID
;  4. Add X pixels (negative removes)
;  5. Add Y pixels (negative removes)
;  6. Tooltip
;  7. Disable Image Gadget (#True/#False)
;
; V1.0 - 12/JAN/2024
;
Procedure PlaceImagetAtXY(MARCOAGPINTO_gadget_target,MARCOAGPINTO_x,MARCOAGPINTO_y,MARCOAGPINTO_image_id,MARCOAGPINTO_add_x_pixels,MARCOAGPINTO_add_y_pixels,MARCOAGPINTO_tooltip$,MARCOAGPINTO_disabled)
  
  MARCOAGPINTO_x+MARCOAGPINTO_add_x_pixels
  MARCOAGPINTO_y+MARCOAGPINTO_add_y_pixels
  
  ImageGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_x,MARCOAGPINTO_y,ImageWidth(MARCOAGPINTO_image_id),ImageHeight(MARCOAGPINTO_image_id),ImageID(MARCOAGPINTO_image_id))
  DisableGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_disabled)
  If MARCOAGPINTO_tooltip$<>""
;     MARCOAGPINTO_tooltip$=ReplaceString(MARCOAGPINTO_tooltip$,". ","."+#LF$+#LF$)
    GadgetToolTip(MARCOAGPINTO_gadget_target,MARCOAGPINTO_tooltip$)
  EndIf
  
EndProcedure




; Places an image AFTER a gadget with distance from the gadget and tooltip, etc.
;
; 10/NOV/2023: Swapped 1 with 2
;
;  1. Gadget Source
;  2. Gadget Target (image)
;  3. Image ID
;  4. Add X pixels (negative removes)
;  5. Add Y pixels (negative removes)
;  6. Tooltip
;  7. Disable Image Gadget (#True/#False)
;
; V1.0 - 19/OCT/2023
; V1.1 - 08/NOV/2023
;        o Tooltip now uses paragraphs if it finds ". "
;
Procedure PlaceImageAfterGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_gadget_source,MARCOAGPINTO_image_id,MARCOAGPINTO_add_x_pixels,MARCOAGPINTO_add_y_pixels,MARCOAGPINTO_tooltip$,MARCOAGPINTO_disabled)
  
  MARCOAGPINTO_x=GadgetX(MARCOAGPINTO_gadget_source)+MARCOAGPINTO_add_x_pixels
  MARCOAGPINTO_y=GadgetY(MARCOAGPINTO_gadget_source)+MARCOAGPINTO_add_y_pixels
  MARCOAGPINTO_x+GadgetWidth(MARCOAGPINTO_gadget_source)
  
  ImageGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_x,MARCOAGPINTO_y,ImageWidth(MARCOAGPINTO_image_id),ImageHeight(MARCOAGPINTO_image_id),ImageID(MARCOAGPINTO_image_id))
  DisableGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_disabled)
  If MARCOAGPINTO_tooltip$<>""
;     MARCOAGPINTO_tooltip$=ReplaceString(MARCOAGPINTO_tooltip$,". ","."+#LF$+#LF$)
    GadgetToolTip(MARCOAGPINTO_gadget_target,MARCOAGPINTO_tooltip$)
  EndIf
  
EndProcedure




; Places an image BEFORE a gadget with distance from the gadget and tooltip, etc.
;
; 10/NOV/2023: Swapped 1 with 2
;
;  1. Gadget Source
;  2. Gadget Target (image)
;  3. Image ID
;  4. Add X pixels (negative removes)
;  5. Add Y pixels (negative removes)
;  6. Tooltip
;  7. Disable Image Gadget (#True/#False)
;
; V1.0 - 19/OCT/2023
; V1.1 - 08/NOV/2023
;        o Tooltip now uses paragraphs if it finds ". "
;
Procedure PlaceImageBeforeGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_gadget_source,MARCOAGPINTO_image_id,MARCOAGPINTO_add_x_pixels,MARCOAGPINTO_add_y_pixels,MARCOAGPINTO_tooltip$,MARCOAGPINTO_disabled)
  
  MARCOAGPINTO_x=GadgetX(MARCOAGPINTO_gadget_source)-MARCOAGPINTO_add_x_pixels
  MARCOAGPINTO_y=GadgetY(MARCOAGPINTO_gadget_source)+MARCOAGPINTO_add_y_pixels
  MARCOAGPINTO_x-GadgetWidth(MARCOAGPINTO_gadget_source)
  
  ImageGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_x,MARCOAGPINTO_y,ImageWidth(MARCOAGPINTO_image_id),ImageHeight(MARCOAGPINTO_image_id),ImageID(MARCOAGPINTO_image_id))
  DisableGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_disabled)
  If MARCOAGPINTO_tooltip$<>""
;     MARCOAGPINTO_tooltip$=ReplaceString(MARCOAGPINTO_tooltip$,". ","."+#LF$+#LF$)
    GadgetToolTip(MARCOAGPINTO_gadget_target,MARCOAGPINTO_tooltip$)
  EndIf
  
EndProcedure




; Places an ButtonImageGadget AT (x,y) with distance from the (x,y) and tooltip, etc.
;
; 10/NOV/2023: Swapped 1 with 2
;
;  1. Gadget Source
;  2. Gadget Target (Gadget)
;  3. Gadget Target Width
;  4. Gadget Target Height
;  5. Image ID
;  6. Add X pixels (negative removes)
;  7. Add Y pixels (negative removes)
;  8. Tooltip
;  9. Disable Gadget Gadget (#True/#False)
;
; V1.0 - 12/JAN/2024
;
Procedure PlaceButtonImageGadgetAtXY(MARCOAGPINTO_gadget_target,MARCOAGPINTO_x,MARCOAGPINTO_y,MARCOAGPINTO_width,MARCOAGPINTO_height,MARCOAGPINTO_image_id,MARCOAGPINTO_add_x_pixels,MARCOAGPINTO_add_y_pixels,MARCOAGPINTO_tooltip$,MARCOAGPINTO_disabled)
  
  MARCOAGPINTO_x+MARCOAGPINTO_add_x_pixels
  MARCOAGPINTO_y+MARCOAGPINTO_add_y_pixels
  
  ButtonImageGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_x,MARCOAGPINTO_y,MARCOAGPINTO_width,MARCOAGPINTO_height,ImageID(MARCOAGPINTO_image_id))
  DisableGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_disabled)
  If MARCOAGPINTO_tooltip$<>""
;     MARCOAGPINTO_tooltip$=ReplaceString(MARCOAGPINTO_tooltip$,". ","."+#LF$+#LF$)
    GadgetToolTip(MARCOAGPINTO_gadget_target,MARCOAGPINTO_tooltip$)
  EndIf
  
EndProcedure




; Places a ButtonImageGadget AFTER a gadget with distance from the gadget and tooltip, etc.
;
;
; 10/NOV/2023: Swapped 1 with 2
;
;  1. Gadget Source
;  2. Gadget Target (image)
;  3. Gadget Target Width
;  4. Gadget Target Height
;  5. Image ID
;  6. Add X pixels (negative removes)
;  7. Add Y pixels (negative removes)
;  8. Tooltip
;  9. Disable Image Gadget (#True/#False)
;
; V1.0 - 21/OCT/2023
; V1.1 - 08/NOV/2023
;        o Tooltip now uses paragraphs if it finds ". "
;
Procedure PlaceButtonImageGadgetAfterGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_gadget_source,MARCOAGPINTO_width,MARCOAGPINTO_height,MARCOAGPINTO_image_id,MARCOAGPINTO_add_x_pixels,MARCOAGPINTO_add_y_pixels,MARCOAGPINTO_tooltip$,MARCOAGPINTO_disabled)
  
  MARCOAGPINTO_x=GadgetX(MARCOAGPINTO_gadget_source)+MARCOAGPINTO_add_x_pixels
  MARCOAGPINTO_y=GadgetY(MARCOAGPINTO_gadget_source)+MARCOAGPINTO_add_y_pixels
  MARCOAGPINTO_x+GadgetWidth(MARCOAGPINTO_gadget_source)
  
  ButtonImageGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_x,MARCOAGPINTO_y,MARCOAGPINTO_width,MARCOAGPINTO_height,ImageID(MARCOAGPINTO_image_id))
  DisableGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_disabled)
  If MARCOAGPINTO_tooltip$<>""
;     MARCOAGPINTO_tooltip$=ReplaceString(MARCOAGPINTO_tooltip$,". ","."+#LF$+#LF$)
    GadgetToolTip(MARCOAGPINTO_gadget_target,MARCOAGPINTO_tooltip$)
  EndIf
  
EndProcedure




; Places a ButtonImageGadget BEFORE a gadget with distance from the gadget and tooltip, etc.
;
;
; 10/NOV/2023: Swapped 1 with 2
;
;  1. Gadget Source
;  2. Gadget Target (image)
;  3. Gadget Target Width
;  4. Gadget Target Height
;  5. Image ID
;  6. Add X pixels (negative removes)
;  7. Add Y pixels (negative removes)
;  8. Tooltip
;  9. Disable Image Gadget (#True/#False)
;
; V1.0 - 21/OCT/2023
; V1.1 - 08/NOV/2023
;        o Tooltip now uses paragraphs if it finds ". "
;
Procedure PlaceButtonImageGadgetBeforeGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_gadget_source,MARCOAGPINTO_width,MARCOAGPINTO_height,MARCOAGPINTO_image_id,MARCOAGPINTO_add_x_pixels,MARCOAGPINTO_add_y_pixels,MARCOAGPINTO_tooltip$,MARCOAGPINTO_disabled)
  
  MARCOAGPINTO_x=GadgetX(MARCOAGPINTO_gadget_source)-MARCOAGPINTO_add_x_pixels
  MARCOAGPINTO_y=GadgetY(MARCOAGPINTO_gadget_source)+MARCOAGPINTO_add_y_pixels
  MARCOAGPINTO_x-GadgetWidth(MARCOAGPINTO_gadget_source)
  
  ButtonImageGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_x,MARCOAGPINTO_y,MARCOAGPINTO_width,MARCOAGPINTO_height,ImageID(MARCOAGPINTO_image_id))
  DisableGadget(MARCOAGPINTO_gadget_target,MARCOAGPINTO_disabled)
  If MARCOAGPINTO_tooltip$<>""
;     MARCOAGPINTO_tooltip$=ReplaceString(MARCOAGPINTO_tooltip$,". ","."+#LF$+#LF$)
    GadgetToolTip(MARCOAGPINTO_gadget_target,MARCOAGPINTO_tooltip$)
  EndIf
  
EndProcedure




; Gets the x-coordinate after a gadget (GadgetX+GadgetWidth)
;
; V1.0 - 02/NOV/2023
;
Procedure GadgetXplusGadgetWidth(MARCOAGPINTO_gadget)
  
  ProcedureReturn GadgetX(MARCOAGPINTO_gadget)+GadgetWidth(MARCOAGPINTO_gadget)
  
EndProcedure




; Gets the y-coordinate after a gadget (GadgetY+GadgetHeight)
;
; V1.0 - 02/NOV/2023
;
Procedure GadgetYplusGadgetHeight(MARCOAGPINTO_gadget)
  
  ProcedureReturn GadgetY(MARCOAGPINTO_gadget)+GadgetHeight(MARCOAGPINTO_gadget)
  
EndProcedure




; Places a text gadget on the GUI with GadgetFit activated, to avoid an extra command.
;
; V1.0 - 13/NOV/2023
;
Procedure TextGadgetGadgetFit(MARCOAGPINTO_gadget,MARCOAGPINTO_x,MARCOAGPINTO_y,MARCOAGPINTO_text$)
  
  ; Place the gadget on the GUI
  TextGadget(MARCOAGPINTO_gadget,MARCOAGPINTO_x,MARCOAGPINTO_y,5,5,MARCOAGPINTO_text$)
  
  ; Fit the gadget
  GadgetFit(MARCOAGPINTO_gadget)
  
EndProcedure




; Checks if the Editor/Text gadget text differs from the one we want to place.
;
; If it differs, it places the new in the gadget and allows to GadgetFit if the flag is set to #True
; (only uses GadgetFit if text different)
;
; V1.0 - 12/JAN/2024
;
Procedure TextReplaceIfDifferentGadget(MARCOAGPINTO_gadget,MARCOAGPINTO_text$,MARCOAGPINTO_gadget_fit)
  
  If GetGadgetText(MARCOAGPINTO_gadget)<>MARCOAGPINTO_text$
    SetGadgetText(MARCOAGPINTO_gadget,MARCOAGPINTO_text$)
    
    ; Fit the gadget
    If MARCOAGPINTO_gadget_fit=#True: GadgetFit(MARCOAGPINTO_gadget) : EndIf
  EndIf
  
EndProcedure

; IDE Options = PureBasic 6.04 LTS (Windows - x64)
; CursorPosition = 773
; FirstLine = 773
; Folding = ----------
; EnableXP
; CompileSourceDirectory